// ========================= Atxmega64A1 CPU ׽Ʈ α׷ ==================
//  CPU : ATmega64A1
//     ¥ : 2010-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 2.04.6
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>							// CPU  

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>
#include <delay.h>
//#include <float.h>
//#include <math.h>

//  ۼ ̺귯 
#include "port_drv.h"						// CPU Ʈ 
#include "usart_drv.h"						//  
#include "adc_drv.h"						// ADC 
#include "dac_drv.h"						// DAC 
#include "ebi_drv.h"						// EX BUS(SRAM,SDRAM) 

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_port_all_output(void);					// CPU PORT ALL Output TEST
void cpu_port_d_output(void);					// CPU PORT D Output TEST
void cpu_port_e_input(void);					// CPU PORT E Input TEST
void cpu_port_e_int0(void);					// CPU PORT E Interrupt0

void com8_test(void);						// COM8 TEST

void timer_c0_test(void);					// timer0(TCC0) TEST
void timer_c1_test(void);					// timer1(TCC1) TEST
void timer_d0_test(void);					// timer2(TCD0) TEST
void timer_d1_test(void);					// timer3(TCD1) TEST
void timer_e0_test(void);					// timer4(TCE0) TEST
void timer_e1_test(void);					// timer5(TCE1) TEST
void timer_f0_test(void);					// timer6(TCF0) TEST
void timer_f1_test(void);					// timer7(TCF0) TEST

void adca_polling_test(void);					// ADC A polling TEST
void dacb_test(void);						// DAC B TEST

void sdram_test(void);						// SDRAM TEST
void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ =============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '1') cpu_port_all_output();// CPU I/O PORT TEST
			else if(com7_rx_data == '2') cpu_port_d_output();// CPU PORT D Output TEST
			else if(com7_rx_data == '3') cpu_port_e_input();// CPU PORT E Input TEST
			else if(com7_rx_data == '4') cpu_port_e_int0();	// CPU PORT E INT0 TEST
			else if(com7_rx_data == '5') com8_test();// COM8 TEST
			else if(com7_rx_data == '6') sdram_test();// SDRAM TEST
			else if(com7_rx_data == 'a') timer_c0_test();// timer0 TEST
			else if(com7_rx_data == 'b') timer_c1_test();// timer1 TEST
			else if(com7_rx_data == 'c') timer_d0_test();// timer2 TEST
			else if(com7_rx_data == 'd') timer_d1_test();// timer3 TEST
			else if(com7_rx_data == 'e') timer_e0_test();// timer4 TEST
			else if(com7_rx_data == 'f') timer_e1_test();// timer5 TEST
			else if(com7_rx_data == 'g') timer_f0_test();// timer6 TEST
			else if(com7_rx_data == 'h') timer_f1_test();// timer7 TEST
			else if(com7_rx_data == 'i') adca_polling_test();// ADC A polling TEST
			else if(com7_rx_data == 'j') dacb_test();//DAC B TEST
			else putchar(com7_rx_data);
			com7_rx_eflg = 0;
		}
	}
}

// ===================================  ޴ ǥ ========================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : CPU PORT ALL Output TEST                 \r\n");
	printf("- 2  : CPU PORT D Output TEST                   \r\n");
	printf("- 3  : CPU PORT E Inputt TEST                   \r\n");
	printf("- 4  : PORTE[0..3] INT0 Falling Edge            \r\n");
	printf("- 5  : COM8(usartf1) TEST                       \r\n");
	printf("- 6  : SDRAM   TEST                             \r\n");
	printf("- a  : TIMER0 TCC0 TEST                         \r\n");
	printf("- b  : TIMER1 TCC1 TEST                         \r\n");
	printf("- c  : TIMER2 TCD0 TEST                         \r\n");
	printf("- d  : TIMER3 TCD1 TEST                         \r\n");
	printf("- e  : TIMER4 TCE0 TEST                         \r\n");
	printf("- f  : TIMER5 TCE1 TEST                         \r\n");
	printf("- g  : TIMER6 TCF0 TEST                         \r\n");
	printf("- h  : TIMER7 TCF1 TEST                         \r\n");
	printf("- i  : ADC A CH0-3 POLLING TEST                 \r\n");
	printf("- j  : DAC B TEST                                 \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ====================== CPU PORT ALL Output TEST ==========================
// [μ]: void
// --------------------------------------------------------------------------
void cpu_port_all_output(void)
{
unsigned char data_c;	
int out_cnt = 0,exit_flg = 0;

	printf("============== CPU PORT ALL Output ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");

// CPU PORT   
// PORTn.OUT : PORT  
// PORTn.OUTSET : 1 Ʈ ش PORT  1
// PORTn.OUTCLR : 1 Ʈ ش PORT  0
// PORTn.OUTTGL : 1 Ʈ ش PORT  TOGGLE 
// PORTn.DIR : PORT   (Է(0),(1)
// PORTn.DIRSET : 1 Ʈ ش PORT     1 set
// PORTn.DIRCLR : 1 Ʈ ش PORT     0 clear
// PORTnPINxCTRL: ش Ʈ bit Pin Configuration
//                1. Slew Rate Limit Enable(PORT_SRLEN_bm)
//                2. Inverted I/O Enable(PORT_INVEN_bm) :  ½
//                3. Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
//                4. Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)

	PORTA.OUT = 0xff;
	PORTA.DIR = 0xff;
	PORTB.OUT = 0xfe;
	PORTB.DIR = 0xfe;					// VREFB 
	PORTC.OUT = 0xff;
	PORTC.DIR = 0xff;
	PORTD.OUT = 0xff;
	PORTD.DIR = 0xff;
	PORTE.OUT = 0xff;
	PORTE.DIR = 0xff;
	PORTF.OUT = 0xbb;
	PORTF.DIR = 0xbb;					// USARTF0,1 Ʈ 
	PORTH.OUT = 0xff;
	PORTH.DIR = 0xff;
	PORTJ.OUT = 0xff;
	PORTJ.DIR = 0xff;
	PORTK.OUT = 0xff;
	PORTK.DIR = 0xff;
	PORTQ.OUT = 0x0c;
	PORTQ.DIR = 0x0c;					// 32.768KHz X-TAL Ʈ 
// ---------------------------------------------------------

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCC0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCC0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCC0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCC0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCC0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCC0.INTFLAGS ^= TCC0.INTFLAGS;				// Clear the interrupt flags

	TCC0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCC0.PER = 0x0000;					// Set period register
	TCC0.CCA = 0x0000;					// Compare,Capture register
	TCC0.CCB = 0x0000;
	TCC0.CCC = 0x0000;
	TCC0.CCD = 0x0000;
// ---------------------------------------------------------

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt < 8) PORTA.OUT = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt < 16){// PORTB 
				if(out_cnt == 8) PORTA.OUT = 0xff;// PORTA CLEAR
				if(!(out_cnt == 8)){		// PORTB_0(VREFA )
					PORTB.OUT = ~(1 << (out_cnt-8));// PORTB (ش Ʈ 0)
				}
			}
			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
				if(out_cnt == 16) PORTB.OUT = 0xfe;// PORTB CLEAR
				PORTC.OUT = ~(1 << (out_cnt-16));// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 24 && out_cnt < 32){	// PORTD 
				if(out_cnt == 24) PORTC.OUT = 0xff;// PORTC CLEAR
				PORTD.OUT = ~(1 << (out_cnt-24));// PORTD (ش Ʈ 0)
			}
			else if(out_cnt >= 32 && out_cnt < 40){	// PORTE 
				if(out_cnt == 32) PORTD.OUT = 0xff;// PORTD CLEAR
				PORTE.OUT = ~(1 << (out_cnt-32));// PORTE (ش Ʈ 0)
			}
			else if(out_cnt >= 40 && out_cnt < 48){	// PORTF (USARTF0,1 )
				if(out_cnt == 40) PORTE.OUT = 0xff;// PORTE CLEAR
				if(!(out_cnt == 42 || out_cnt == 43 || out_cnt == 46 || out_cnt == 47)){
					data_c = ~(1 << (out_cnt-40));// PORTF (ش Ʈ 0)
					PORTF.OUT = data_c & 0xbb;// USARTF0,1 
				}
			}
			else if(out_cnt >= 48 && out_cnt < 56){	// PORTH 
				if(out_cnt == 48) PORTF.OUT = 0xbb;// PORTF CLEAR
				PORTH.OUT = ~(1 << (out_cnt-48));// PORTH (ش Ʈ 0)
			}
			else if(out_cnt >= 56 && out_cnt < 64){	// PORTJ 
				if(out_cnt == 56) PORTH.OUT = 0xff;// PORTH CLEAR
				PORTJ.OUT = ~(1 << (out_cnt-56));// PORTJ (ش Ʈ 0)
			}
			else if(out_cnt >= 64 && out_cnt < 72){	// PORTK 
				if(out_cnt == 64) PORTJ.OUT = 0xff;// PORTJ CLEAR
				PORTK.OUT = ~(1 << (out_cnt-64));// PORTK (ش Ʈ 0)
			}
			else if(out_cnt >= 72 && out_cnt < 76){	// PORTQ 
				if(out_cnt == 72) PORTK.OUT = 0xff;// PORTK CLEAR(XTAL2 )
				if(!(out_cnt == 72 || out_cnt == 73)){
					data_c = ~(1 << (out_cnt-72));// PORTF (ش Ʈ 0)
					PORTQ.OUT = data_c & 0x0c;// XTAL2 
				}
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 77) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTA.OUT = 0xff;
				PORTB.OUT = 0xfe;
				PORTC.OUT = 0xff;
				PORTD.OUT = 0xff;
				PORTE.OUT = 0xff;
				PORTF.OUT = 0xbb;
				PORTH.OUT = 0xff;
				PORTJ.OUT = 0xff;
				PORTK.OUT = 0xff;
				PORTQ.OUT = 0x0c;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCC0.CTRLA = 0;
	TCC0.CTRLB = 0;
	TCC0.CTRLD = 0;
	TCC0.INTCTRLA = 0;
	TCC0.INTCTRLB = 0;
	TCC0.INTFLAGS = 0;

// CPU PORT ʱⰪ  
	PORTA.OUT = 0x00;
	PORTA.DIR = 0x00;
	PORTB.OUT = 0x00;
	PORTB.DIR = 0x00;
	PORTC.OUT = 0x00;
	PORTC.DIR = 0x00;
	PORTD.OUT = 0x00;
	PORTD.DIR = 0x00;
	PORTE.OUT = 0x00;
	PORTE.DIR = 0x00;
	PORTF.OUT = 0x88;					// USARTF0,1 
	PORTF.DIR = 0x88;
	PORTH.OUT = 0x00;
	PORTH.DIR = 0x00;
	PORTJ.OUT = 0x00;
	PORTJ.DIR = 0x00;
	PORTK.OUT = 0x00;
	PORTK.DIR = 0x00;
	PORTQ.OUT = 0x00;					// XTAL2 
	PORTQ.DIR = 0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ======================== CPU PORT D Output TEST ==========================
// [μ]: void
// --------------------------------------------------------------------------
void cpu_port_d_output(void)
{
int exit_flg = 0;

	printf("=============== CPU PORT D Output ===============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");

// CPU PORT   
// PORTn.OUT : PORT  
// PORTn.OUTSET : 1 Ʈ ش PORT  1
// PORTn.OUTCLR : 1 Ʈ ش PORT  0
// PORTn.OUTTGL : 1 Ʈ ش PORT  TOGGLE 
// PORTn.DIR : PORT   (Է(0),(1)
// PORTn.DIRSET : 1 Ʈ ش PORT     1 set
// PORTn.DIRCLR : 1 Ʈ ش PORT     0 clear
// PORTnPINxCTRL: ش Ʈ bit Pin Configuration
//                1. Slew Rate Limit Enable(PORT_SRLEN_bm)
//                2. Inverted I/O Enable(PORT_INVEN_bm) :  ½
//                3. Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
//                4. Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)

	PORTD.OUT = 0xff;
	PORTD.DIRSET = 0xff;
// ---------------------------------------------------------

	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		PORTD.OUT = 0xff;				// PORTD CLEAR
		delay_ms(500);					// 500ms ð 
		PORTD.OUT = 0x00;				// PORTD CLEAR
		delay_ms(500);					// 500ms ð 
	}

// CPU PORT ʱⰪ  
	PORTD.OUTCLR = 0xff;
	PORTD.DIRCLR = 0xff;
	
	main_menu_disp();					//  ޴ ǥ
}

// ======================== CPU PORT E Inputt TEST ==========================
// [μ]: void
// --------------------------------------------------------------------------
void cpu_port_e_input(void)
{
unsigned char datac;	
int exit_flg = 0;

	printf("=============== CPU PORT E Inputt ===============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : PORT E Input(NOT,Internall PULL-UP)       \r\n");
	printf("-------------------------------------------------\r\n");

// CPU PORT Է  
// PORTn.IN : PORT Է 
// PORTn.DIR : PORT   (Է(0),(1)
// PORTn.DIRSET : 1 Ʈ ش PORT     1 set
// PORTn.DIRCLR : 1 Ʈ ش PORT     0 clear
// PORTnPINxCTRL: ش Ʈ bit Pin Configuration
//                1. Slew Rate Limit Enable(PORT_SRLEN_bm)
//                2. Inverted I/O Enable(PORT_INVEN_bm) :  ½
//                3. Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
//                4. Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)
 
	PORTE.OUT = 0xff;
	PORTE.DIRSET = 0x00;
/*	
// PORTE PIN() :: PULL-UP, Է 
	PORTE.PIN0CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_0 PULL-UP
	PORTE.PIN1CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_1 PULL-UP
	PORTE.PIN2CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_2 PULL-UP
	PORTE.PIN3CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_3 PULL-UP
	PORTE.PIN4CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_4 PULL-UP
	PORTE.PIN5CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_5 PULL-UP
	PORTE.PIN6CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_6 PULL-UP
	PORTE.PIN7CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_7 PULL-UP
// PORTE PIN(ü) ::  PULL-UP, Է 
	datac = PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;	// PORTE_0-7  (PULL-UP, inverted Է)
	PORTCFG.MPCMASK = 0xff;					// Multi Pin Configuration Mask Register
	PORTE.PIN0CTRL = datac;					// Pin Configuration Register
*/

// PORTE PIN() :: PULL-UP, Է (NOT)
	PORTE.PIN0CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_0 PULL-UP inverted Է
	PORTE.PIN1CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_1 PULL-UP inverted Է
	PORTE.PIN2CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_2 PULL-UP inverted Է
	PORTE.PIN3CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_3 PULL-UP inverted Է
	PORTE.PIN4CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_4 PULL-UP inverted Է
	PORTE.PIN5CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_5 PULL-UP inverted Է
	PORTE.PIN6CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_6 PULL-UP inverted Է
	PORTE.PIN7CTRL = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_7 PULL-UP inverted Է
// PORTE PIN(ü) ::  PULL-UP, Է (NOT)
//	datac = PORT_INVEN_bm | PORT_OPC_PULLUP_gc | PORT_ISC_BOTHEDGES_gc;// PORTE_0-7  (PULL-UP, inverted Է)
//	PORTCFG.MPCMASK = 0xff;					// Multi Pin Configuration Mask Register
//	PORTE.PIN0CTRL = datac;					// Pin Configuration Register
// ---------------------------------------------------------

	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			if(com7_rx_data == '1'){		// PORT Input
				datac = PORTE.IN;
				printf("PORT_E > %02x\r\n",datac);
			}
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
	}
// PORTE PIN(ü) ::  clear
	PORTE.OUT = 0x00;
	PORTE.DIRSET = 0x00;

	datac = 0x00;						// PORTE_0-7 ü ʱȭ
	PORTCFG.MPCMASK = 0xff;					// Multi Pin Configuration Mask Register
	PORTE.PIN0CTRL = datac;					// Pin Configuration Register

	main_menu_disp();					//  ޴ ǥ
}

// ====================== CPU PORT E Interrupt0 TEST ========================
// [μ]: void
// --------------------------------------------------------------------------
void cpu_port_e_int0(void)
{
unsigned char datac;	
int exit_flg = 0;

	printf("=============== CPU PORT E INT0 =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- * PORTE[0..3] Falling Edge Interrupt0          \r\n");
	printf("-------------------------------------------------\r\n");

// CPU PORT Է  
// PORTn.IN : PORT Է 
// PORTn.DIR : PORT   (Է(0),(1)
// PORTn.DIRSET : 1 Ʈ ش PORT     1 set
// PORTn.DIRCLR : 1 Ʈ ش PORT     0 clear
// PORTnPINxCTRL: ش Ʈ bit Pin Configuration
//                1. Slew Rate Limit Enable(PORT_SRLEN_bm)
//                2. Inverted I/O Enable(PORT_INVEN_bm) :  ½
//                3. Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
//                4. Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)
// PORTn.INTCTRL: Interrupt Control Register
//                1. Interrupt0 Level[0..1]
//                2. Interrupt1 Level[2..3]
// PORTn.INT0MASK : Interrupt0 Mask Register
// PORTn.INT1MASK : Interrupt1 Mask Register

	PORTE.OUT = 0xff;
	PORTE.DIRSET = 0x00;
	
// PORTE_0-3 PIN() :: PULL-UP, Է 
	PORTE.PIN0CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;// PORTE_0 PULL-UP, Falling Edge
	PORTE.PIN1CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;// PORTE_1 PULL-UP, Falling Edge
	PORTE.PIN2CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;// PORTE_2 PULL-UP, Falling Edge
	PORTE.PIN3CTRL = PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;// PORTE_3 PULL-UP, Falling Edge

	PORTE.INTCTRL = PORT_INT1LVL_OFF_gc | PORT_INT0LVL_LO_gc;// PORTE->INT0 LO Level Interrupt set
	PORTE.INT0MASK=0x0f;					// Interrupt0 Mask Register(PORTE_0..3 interrupt)
	PORTE.INT1MASK=0x00;					// Interrupt1 Mask Register

	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(exint0_flg_0){				// PORTE_0 falling edge ͷƮ
			printf("PORTE_0 Falledge Interrupt\r\n");
			exint0_flg_0 = 0;
		}
		if(exint0_flg_1){				// PORTE_1 falling edge ͷƮ
			printf("PORTE_1 Falledge Interrupt\r\n");
			exint0_flg_1 = 0;
		}
		if(exint0_flg_2){				// PORTE_2 falling edge ͷƮ
			printf("PORTE_2 Falledge Interrupt\r\n");
			exint0_flg_2 = 0;
		}
		if(exint0_flg_3){				// PORTE_3 falling edge ͷƮ
			printf("PORTE_3 Falledge Interrupt\r\n");
			exint0_flg_3 = 0;
		}
	}
// PORTE PIN(ü) ::  clear
	PORTE.OUT = 0x00;
	PORTE.DIRSET = 0x00;

	datac = 0x00;						// PORTE_0-7 ü ʱȭ
	PORTCFG.MPCMASK = 0xff;					// Multi Pin Configuration Mask Register
	PORTE.PIN0CTRL = datac;					// Pin Configuration Register

	PORTE.INTCTRL = 0x00;					// PORTE interrupt control clear
	PORTE.INT0MASK=0x00;					// Interrupt0 Mask Register
	PORTE.INT1MASK=0x00;					// Interrupt1 Mask Register

	main_menu_disp();					//  ޴ ǥ
}

// ==================================== COM8 TEST =============================
// [μ] void
// ----------------------------------------------------------------------------
void com8_test(void)
{
int exit_flg = 0;

	printf("================== COM8 TEST ===================\r\n");
	printf("- 0  : RETURN TOP MENU                          \r\n");
	printf("- * COM7 <-> COM8                               \r\n");
	printf("------------------------------------------------\r\n");
	
	com7_rx_eflg = com8_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;
			else putchar_8(com7_rx_data);		// COM8 send
			com7_rx_eflg = 0;
		}
		if(com8_rx_eflg){				// COM8  ˻
			putchar(com7_rx_data);			// COM7 send
			com8_rx_eflg = 0;
		}
	}
	main_menu_disp();					// ޴ ǥ
}

// =========================== timer0(TCC0) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_c0_test(void)
{
int exit_flg = 0;

	printf("============= TIMER0(TCC0) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER0(TCC0) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCC0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCC0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCC0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCC0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCC0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCC0.INTFLAGS ^= TCC0.INTFLAGS;				// Clear the interrupt flags

	TCC0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCC0.PER = 0x0000;					// Set period register
	TCC0.CCA = 0x0000;					// Compare,Capture register
	TCC0.CCB = 0x0000;
	TCC0.CCC = 0x0000;
	TCC0.CCD = 0x0000;
// ---------------------------------------------------------

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("Timer0(TCC0) Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCC0.CTRLA = 0;
	TCC0.CTRLB = 0;
	TCC0.CTRLD = 0;
	TCC0.INTCTRLA = 0;
	TCC0.INTCTRLB = 0;
	TCC0.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer1(TCC1) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_c1_test(void)
{
int exit_flg = 0;

	printf("============= TIMER1(TCC1) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER1(TCC1) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC1 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCC1.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCC1.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCC1.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCC1.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCC1.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCC1.INTFLAGS ^= TCC1.INTFLAGS;				// Clear the interrupt flags

	TCC1.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCC1.PER = 0x0000;					// Set period register
	TCC1.CCA = 0x0000;					// Compare,Capture register
	TCC1.CCB = 0x0000;
// ---------------------------------------------------------

	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 999.84ms üũ
			printf("Timer1(TCC1) Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCC1.CTRLA = 0;
	TCC1.CTRLB = 0;
	TCC1.CTRLD = 0;
	TCC1.INTCTRLA = 0;
	TCC1.INTCTRLB = 0;
	TCC1.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer2(TCD0) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_d0_test(void)
{
int exit_flg = 0;

	printf("============= TIMER2(TCD0) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER2(TCD0) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCD0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCD0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCD0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCD0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCD0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCD0.INTFLAGS ^= TCD0.INTFLAGS;				// Clear the interrupt flags

	TCD0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCD0.PER = 0x0000;					// Set period register
	TCD0.CCA = 0x0000;					// Compare,Capture register
	TCD0.CCB = 0x0000;
	TCD0.CCC = 0x0000;
	TCD0.CCD = 0x0000;
// ---------------------------------------------------------

	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("Timer2(TCD0) Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCD0.CTRLA = 0;
	TCD0.CTRLB = 0;
	TCD0.CTRLD = 0;
	TCD0.INTCTRLA = 0;
	TCD0.INTCTRLB = 0;
	TCD0.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer3(TCD1) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_d1_test(void)
{
int exit_flg = 0;

	printf("============= TIMER3(TCD1) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER3(TCD1) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC1 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCD1.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCD1.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCD1.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCD1.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCD1.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCD1.INTFLAGS ^= TCD1.INTFLAGS;				// Clear the interrupt flags

	TCD1.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCD1.PER = 0x0000;					// Set period register
	TCD1.CCA = 0x0000;					// Compare,Capture register
	TCD1.CCB = 0x0000;
// ---------------------------------------------------------

	timer3_cnt = 0;						// TIMER3 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer3_cnt >= 100){				// 999.84ms üũ
			printf("Timer3(TCD1) Overflow Interrupt\r\n");
			timer3_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCD1.CTRLA = 0;
	TCD1.CTRLB = 0;
	TCD1.CTRLD = 0;
	TCD1.INTCTRLA = 0;
	TCD1.INTCTRLB = 0;
	TCD1.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer4(TCE0) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_e0_test(void)
{
int exit_flg = 0;

	printf("============= TIMER4(TCE0) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER4(TCE0) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCE0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCE0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCE0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCE0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCE0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCE0.INTFLAGS ^= TCE0.INTFLAGS;				// Clear the interrupt flags

	TCE0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCE0.PER = 0x0000;					// Set period register
	TCE0.CCA = 0x0000;					// Compare,Capture register
	TCE0.CCB = 0x0000;
	TCE0.CCC = 0x0000;
	TCE0.CCD = 0x0000;
// ---------------------------------------------------------

	timer4_cnt = 0;						// TIMER4 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer4_cnt >= 100){				// 999.84ms üũ
			printf("Timer4(TCE0) Overflow Interrupt\r\n");
			timer4_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCE0.CTRLA = 0;
	TCE0.CTRLB = 0;
	TCE0.CTRLD = 0;
	TCE0.INTCTRLA = 0;
	TCE0.INTCTRLB = 0;
	TCE0.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer5(TCE1) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_e1_test(void)
{
int exit_flg = 0;

	printf("============= TIMER5(TCD1) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER5(TCE1) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC1 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCE1.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCE1.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCE1.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCE1.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCE1.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCE1.INTFLAGS ^= TCE1.INTFLAGS;				// Clear the interrupt flags

	TCE1.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCE1.PER = 0x0000;					// Set period register
	TCE1.CCA = 0x0000;					// Compare,Capture register
	TCE1.CCB = 0x0000;
// ---------------------------------------------------------

	timer5_cnt = 0;						// TIMER5 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer5_cnt >= 100){				// 999.84ms üũ
			printf("Timer5(TCE1) Overflow Interrupt\r\n");
			timer5_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCE1.CTRLA = 0;
	TCE1.CTRLB = 0;
	TCE1.CTRLD = 0;
	TCE1.INTCTRLA = 0;
	TCE1.INTCTRLB = 0;
	TCE1.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer6(TCF0) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_f0_test(void)
{
int exit_flg = 0;

	printf("============= TIMER6(TCF0) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER6(TCF0) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC0 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCF0.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCF0.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCF0.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCF0.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCF0.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc | TC_CCCINTLVL_OFF_gc | TC_CCDINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCF0.INTFLAGS ^= TCF0.INTFLAGS;				// Clear the interrupt flags

	TCF0.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCF0.PER = 0x0000;					// Set period register
	TCF0.CCA = 0x0000;					// Compare,Capture register
	TCF0.CCB = 0x0000;
	TCF0.CCC = 0x0000;
	TCF0.CCD = 0x0000;
// ---------------------------------------------------------

	timer6_cnt = 0;						// TIMER6 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer6_cnt >= 100){				// 999.84ms üũ
			printf("Timer6(TCF0) Overflow Interrupt\r\n");
			timer6_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCF0.CTRLA = 0;
	TCF0.CTRLB = 0;
	TCF0.CTRLD = 0;
	TCF0.INTCTRLA = 0;
	TCF0.INTCTRLB = 0;
	TCF0.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// =========================== timer7(TCF1) TEST ============================
// [μ]: void
// --------------------------------------------------------------------------
void timer_f1_test(void)
{
int exit_flg = 0;

	printf("============= TIMER7(TCF1) TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER7(TCf1) Overfow 10.0ms     \r\n");
	printf("- message disp : 10.0ms * 100 = 1000.0ms         \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter TCC1 (Overflow) 9.9984ms :: LED ¿
// 32,000,000Hz / 256 / 1250 =  1 / 100.0 = 10.0ms
	TCF1.CTRLA = TC_CLKSEL_DIV256_gc;			// 32MHz / 256 = 125KHz

	// Normal Operation, Overflow Int./Event = TOP
	// Compare/Capture channel A,B,C,D: Off
	TCF1.CTRLB = TC_WGMODE_NORMAL_gc;			// Control Register B
	TCF1.CTRLD = TC_EVACT_OFF_gc | TC_EVSEL_OFF_gc;		// Capture event source, action :: OFF
	TCF1.INTCTRLA = TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;// interrupt : Overflow(Low Level),Error(Disable)
	TCF1.INTCTRLB = TC_CCAINTLVL_OFF_gc | TC_CCBINTLVL_OFF_gc;// Compare or Capture interrupt(Disabled)
	TCF1.INTFLAGS ^= TCF1.INTFLAGS;				// Clear the interrupt flags

	TCF1.CNT = 64285;					// Set counter register(65535-1250 = 64285)
	TCF1.PER = 0x0000;					// Set period register
	TCF1.CCA = 0x0000;					// Compare,Capture register
	TCF1.CCB = 0x0000;
// ---------------------------------------------------------

	timer7_cnt = 0;						// TIMER7 ͷƮ ī Ŭ
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
		if(timer7_cnt >= 100){				// 999.84ms üũ
			printf("Timer7(TCf1) Overflow Interrupt\r\n");
			timer7_cnt = 0;
		}
	}

// Timer/Counter TCC0 
	TCF1.CTRLA = 0;
	TCF1.CTRLB = 0;
	TCF1.CTRLD = 0;
	TCF1.INTCTRLA = 0;
	TCF1.INTCTRLB = 0;
	TCF1.INTFLAGS = 0;

	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D A POLLING TEST ==========================
// [μ]: void
// []: CH0 : ADCA_0 - DIFF IN(+)
//               ADCA_1 - DIFF IN(-)
//         CH1 : Internal - 1/10 scaled VCC
//         CH2 : ADCA_2 - SINGLE IN(+), GND
//         CH3 : ADCA_3 - SINGLE IN(+), GND
// ---------------------------------------------------------------------------
// ** 1. ⵿ Offset üũ PA1  ϹǷ PA1 GND Է ¿ 
//        Լ  Ѿ մϴ.
//    2. offset üũ ÷ offset = 0 ϼ. 
// ----------------------------------------------------------------------------
void adca_polling_test(void)
{
char offset;	
int datai,exit_flg = 0;

	printf("================= ADCA POLLING TEST =============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0-CH3 READ                              \r\n");
	printf("-------------------------------------------------\r\n");
	printf("-      CH0 : ADCA_0 - DIFF IN(+)                 \r\n"); 
	printf("-            ADCA_1 - DIFF IN(-)                 \r\n");
	printf("-      CH1 : Internal - 1/10 scaled VCC          \r\n");
	printf("-      CH2 : ADCA_2 - SINGLE IN(+), GND          \r\n");
	printf("-      CH3 : ADCA_3 - SINGLE IN(+), GND          \r\n");
	printf("-------------------------------------------------\r\n");

// ADC initialization 
	ADC_CalibrationValues_Load(&ADCA);			// ADCA ޸𸮿  Cal  ε

// ADC Control Register B
// BIT1-2 : ADC Conversion Result Resolution
//          1. 12-bit right-adjusted result(ADC_RESOLUTION_12BIT_gc)
//          2. 8-bit right-adjusted result(ADC_RESOLUTION_8BIT_gc)
//          3. 12-bit left-adjusted result(ADC_RESOLUTION_LEFT12BIT_gc)
// BIT3   : Free Running Mode Enable(ADC_FREERUN_bm)
// BIT4   : ADC Conversion Mode
//          1. unsigned conversion mode(ADC_ConvMode_Unsigned)
//          2. signed conversion mode differential input(ADC_ConvMode_Signed)
  	ADC_ConvMode_and_Resolution_Config(&ADCA, ADC_ConvMode_Signed, ADC_RESOLUTION_12BIT_gc);

// ADC Clock Prescaler register(System Clock)
// BIT0-2 : 1. Divide clock by   4(ADC_PRESCALER_DIV4_gc)
//          2. Divide clock by   8(ADC_PRESCALER_DIV8_gc)
//          3. Divide clock by  16(ADC_PRESCALER_DIV16_gc)
//          4. Divide clock by  32(ADC_PRESCALER_DIV32_gc)
//          5. Divide clock by  64(ADC_PRESCALER_DIV64_gc)
//          6. Divide clock by 128(ADC_PRESCALER_DIV128_gc)
//          7. Divide clock by 256(ADC_PRESCALER_DIV256_gc)
//          8. Divide clock by 512(ADC_PRESCALER_DIV512_gc)
	ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV32_gc);	// Set sample rate. S_CLK / 32 = 1MHz

// ADC Reference Control register(
// BIT0   : Temperature Reference Enable(ADC_TEMPREF_bm)
// BIT1   : Bandgap enable bit(ADC_BANDGAP_bm)
// BIT5-5 : ADC Reference Selection
//          1. Internal 1V(ADC_REFSEL_INT1V_gc)
//          2. Internal VCC(ADC_REFSEL_VCC_gc)
//          3. External reference on PORT A(ADC_REFSEL_AREFA_gc)
//          4. External reference on PORT B(ADC_REFSEL_AREFB_gc)

	ADC_Reference_Config(&ADCA, ADC_REFSEL_VCC_gc); 	// Set reference voltage on ADC A to be VCC/1.6 V
//	ADC_Reference_Config(&ADCA, ADC_REFSEL_AREFB_gc); 	// External reference on PORTB_0(REFB) 2.5V
	
// ADC Channel Control Register
// BIT0   : Input Mode
//          Unsigned Mode 
//          1. Internal inputs, no gain(ADC_CH_INPUTMODE_INTERNAL_gc)
//          2. Single-ended input, no gain(ADC_CH_INPUTMODE_SINGLEENDED_gc)
//          signed Mode 
//          3. Differential input, no gain(ADC_CH_INPUTMODE_DIFF_gc)
//          4. Differential input, with gain(ADC_CH_INPUTMODE_DIFFWGAIN_gc)
// BIT2-4 : ADC Gain Factor
//          1.  1x gain(ADC_CH_GAIN_1X_gc)
//          2.  2x gain(ADC_CH_GAIN_2X_gc)
//          3.  4x gain(ADC_CH_GAIN_4X_gc)
//          4.  8x gain(ADC_CH_GAIN_8X_gc)
//          5. 16x gain(ADC_CH_GAIN_16X_gc)
//          6. 32x gain(ADC_CH_GAIN_32X_gc)
//          7. 64x gain(ADC_CH_GAIN_64X_gc)
// BIT7   : START Conversion on Channel
	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_DIFF_gc,ADC_CH_GAIN_1X_gc);// Setup channel_0 different inputs
	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_INTERNAL_gc,ADC_CH_GAIN_1X_gc);// Setup channel_1 Internal inputs
	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc,ADC_CH_GAIN_1X_gc);// Setup channel_2 Single-ended input inputs
	ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc,ADC_CH_GAIN_1X_gc);// Setup channel_3 Single-ended input inputs
	
// ADC Channel MUX Control registers
// BIT0-1 : Negative input multiplexer selection
//          1. Input pin 0(ADC_CH_MUXNEG_PIN0_gc)
//          2. Input pin 1(ADC_CH_MUXNEG_PIN1_gc)
//          3. Input pin 2(ADC_CH_MUXNEG_PIN2_gc)
//          4. Input pin 3(ADC_CH_MUXNEG_PIN3_gc)
//          5. Input pin 4(ADC_CH_MUXNEG_PIN4_gc)
//          6. Input pin 5(ADC_CH_MUXNEG_PIN5_gc)
//          7. Input pin 6(ADC_CH_MUXNEG_PIN6_gc)
//          8. Input pin 7(ADC_CH_MUXNEG_PIN7_gc)
// BIT3-6 : Internal input multiplexer selections
//          1. Temperature Reference(ADC_CH_MUXINT_TEMP_gc)
//          2. Bandgap Reference(ADC_CH_MUXINT_BANDGAP_gc)
//          3. 1/10 scaled VCC(ADC_CH_MUXINT_SCALEDVCC_gc)
//          4. DAC output(ADC_CH_MUXINT_DAC_gc)
//          Positive input multiplexer selection
//          1. Input pin 0(ADC_CH_MUXPOS_PIN0_gc)
//          2. Input pin 1(ADC_CH_MUXPOS_PIN1_gc)
//          3. Input pin 2(ADC_CH_MUXPOS_PIN2_gc)
//          4. Input pin 3(ADC_CH_MUXPOS_PIN3_gc)
//          5. Input pin 4(ADC_CH_MUXPOS_PIN4_gc)
//          6. Input pin 5(ADC_CH_MUXPOS_PIN5_gc)
//          7. Input pin 6(ADC_CH_MUXPOS_PIN6_gc)
//          8. Input pin 7(ADC_CH_MUXPOS_PIN7_gc)
   	ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);// Get offset value for ADC A.
	ADC_Enable(&ADCA);					//  ADC Channel Control Register BIT7
	ADC_Wait_32MHz(&ADCA);					// Wait until common mode voltage is stable
 	offset = ADC_Offset_Get_Signed(&ADCA.CH0, false);	// Offset Read
//	offset = 0;						// offset   .
	ADC_Disable(&ADCA);					//  ADC Channel Control Register BIT7

	ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
	ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXINT_SCALEDVCC_gc, 0);
	ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, 0);
	ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, 0);

// ADC Event Control Register
// BIT0-2 : Event action selection
//          1. No event action(ADC_EVACT_NONE_gc)
//          2. First event triggers channel 0(ADC_EVACT_CH0_gc)
//          3. First three events trigger channel 0,1(ADC_EVACT_CH01_gc)
//          4. First three events trigger channel 0,1,2(ADC_EVACT_CH012_gc)
//          5. Events trigger channel 0,1,2,3(ADC_EVACT_CH0123_gc)
//          6. First event triggers sweep(ADC_EVACT_SWEEP_gc)
//          7. First event triggers synchronized sweep(ADC_EVACT_SYNCHSWEEP_gc)
// BIT3-5 : Event channel input selection
//          1. Event Channel 0,1,2,3(ADC_EVSEL_0123_gc)
//          2. Event Channel 1,2,3,4(ADC_EVSEL_1234_gc)
//          3. Event Channel 2,3,4,5(ADC_EVSEL_2345_gc)
//          4. Event Channel 3,4,5,6(ADC_EVSEL_3456_gc)
//          5. Event Channel 4,5,6,7(ADC_EVSEL_4567_gc)
//          6. Event Channel 5,6,7(ADC_EVSEL_567_gc)
//          7. Event Channel 6,7(ADC_EVSEL_67_gc)
//          8. Event Channel 7(ADC_EVSEL_7_gc)
// BIT6-7 : Channel sweep selection
//          1. ADC Channel 0(ADC_SWEEP_0_gc)
//          2. ADC Channel 0,1(ADC_SWEEP_01_gc)
//          3. ADC Channel 0,1,2(ADC_SWEEP_012_gc)
//          4. ADC Channel 0,1,2,3(ADC_SWEEP_0123_gc)
	ADC_SweepChannels_Config(&ADCA, ADC_SWEEP_0123_gc);	// Setup sweep of all four virtual channels.
	ADC_Enable(&ADCA);					// Enable ADC A

	ADC_Wait_32MHz(&ADCA);					// Wait until common mode voltage is stable
	ADC_FreeRunning_Enable(&ADCA);				// ADC Control Register B BIT3

	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com7_rx_data == '1'){		// ADC Read
				while(!ADC_Ch_Conversion_Complete(&ADCA.CH0));// CH0 read
				datai = ADC_ResultCh_GetWord_Signed(&ADCA.CH0, offset);
				printf("AD_CH0 > %d\r\n",datai);

				while(!ADC_Ch_Conversion_Complete(&ADCA.CH1));// CH1 read
				datai = ADC_ResultCh_GetWord_Signed(&ADCA.CH1, offset);
				printf("AD_CH1 > %d\r\n",datai);

				while(!ADC_Ch_Conversion_Complete(&ADCA.CH2));// CH2 read
				datai = ADC_ResultCh_GetWord_Signed(&ADCA.CH2, offset);
				printf("AD_CH2 > %d\r\n",datai);

				while(!ADC_Ch_Conversion_Complete(&ADCA.CH3));// CH3 read
				datai = ADC_ResultCh_GetWord_Signed(&ADCA.CH3, offset);
				printf("AD_CH3 > %d\r\n\r\n",datai);
			}
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
	}

// ADC initialization 
	ADC_Disable(&ADCA);					// Disable ADC A
	ADC_Wait_32MHz(&ADCA);					// Wait until common mode voltage is stable
	ADC_FreeRunning_Disable(&ADCA);				// ADC Control Register B BIT3
	
	main_menu_disp();					//  ޴ ǥ
}

// ================================== D/A B TEST ==============================
// [μ]: void
// ----------------------------------------------------------------------------
void dacb_test(void)
{
int exit_flg = 0;
unsigned int angle;

	printf("===================== DA B TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : D/A CH0 Out +  :: PORTB.2                 \r\n");
	printf("- 2  : D/A CH0 Out -                             \r\n");
	printf("-------------------------------------------------\r\n");

// DAC Control Register C
// BIT0   : DAC Left-Adjust Value(fluse,true)
// BIT3-4 : DAC Reference Selection
//          1. Internal 1V(DAC_REFSEL_INT1V_gc)
//          2. Analog supply voltage(DAC_REFSEL_AVCC_gc)
//          3. External reference on AREF on PORTA(DAC_REFSEL_AREFA_gc)
//          4. External reference on AREF on PORTB(DAC_REFSEL_AREFB_gc)

	DAC_SingleChannel_Enable(&DACB,DAC_REFSEL_AVCC_gc,false);
	com7_rx_eflg = 0;
	while(exit_flg == 0){
		if(com7_rx_eflg){				// COM7  ˻
			if(com7_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com7_rx_data == '1'){		// DAC Out+
				for(angle = 0; angle < 0x1000; ++angle){
					while(DAC_Channel_DataEmpty(&DACB,CH0) == false );
					DAC_Channel_Write(&DACB,angle,CH0);
				}
			
			}
			else if(com7_rx_data == '2'){		// DAC Out-
				for(angle = 0; angle < 0x1000; ++angle){
					while(DAC_Channel_DataEmpty(&DACB,CH0) == false );
					DAC_Channel_Write(&DACB,0xfff-angle,CH0);
				}
			}
			else putchar(com7_rx_data);		// ݼ
			com7_rx_eflg = 0;
		}
	}

// DAC initialization 
	DACB.CTRLB = 0x00;
	DACB.CTRLC = 0x00;
	DACB.CTRLA = 0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== SDRAM ׽Ʈ α׷ ======================
// [μ] void
// [] CVAVR far  SDRAM 뿵 64K .(  )
// ---------------------------------------------------------------------------
void sdram_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int j,cnt,exit_flg = 0;
unsigned int sdram_base = 0x4000;
unsigned i,saddr,ecnt;
unsigned char *sdram_addr = (unsigned char*)0x4000;

	printf("============ SDRAM TEST ===========\r\n");
	printf("- 0 : TOP MENU                    -\r\n");
	printf("- 1 : Read  Data(0000-ffffh)      -\r\n");
	printf("- 2 : Write Data(0000-ffffh)      -\r\n");
	printf("-----------------------------------\r\n");

// PORT  SDRAM ʱȭ
	PORTH.OUT = 0x0F;					// Set signals which are active-low to high value
	PORTH.DIR = 0xFF;					// Configure bus pins as outputs(except for data lines).
	PORTK.DIR = 0xFF;
	PORTJ.DIR = 0xF0;
	
	PORTQ.DIR = 0x08;					// Set direction and output value of Chip Select line (Q3).
	PORTQ.OUT = 0x00;
	
	EBI_Enable( EBI_SDDATAW_4BIT_gc,EBI_LPCMODE_ALE1_gc,EBI_SRMODE_ALE12_gc,EBI_IFMODE_3PORT_gc );// Initialize EBI.
// Initialize SDRAM
	EBI_EnableSDRAM( EBI_CS_ASPACE_8MB_gc,   		// 8MB address space.
	                 sdram_base, 		   		// Base address.
	                 false,                  		// 2 cycle CAS Latency.
	                 true,                  		// EBI_SDROW_bm set
	                 EBI_SDCOL_10BIT_gc,      		// 8 Column bits.
	                 EBI_MRDLY_1CLK_gc,      		// 1 cycle Mode Register Delay.
	                 EBI_ROWCYCDLY_1CLK_gc,  		// 1 cycle Row Cycle Delay.
	                 EBI_RPDLY_1CLK_gc,      		// 1 cycle Row to Pre-charge Delay.
	                 EBI_WRDLY_1CLK_gc,      		// 1 cycle Write Recovery Delay.
	                 EBI_ESRDLY_1CLK_gc,     		// 1 cycle Exit Self Refresh to Active Delay.
	                 EBI_ROWCOLDLY_1CLK_gc,  		// 1 cycle Row to Column Delay.
	                 0x03FF,                 		// 1023 cycle Refresh Period (32.8 ms @ 2MHz).
	                 0x0100 );				// 256 cycle Initialization Delay (128 us @ 2MHz)
	com7_rx_eflg = 0;
	while(exit_flg == 0){
	    if(com7_rx_eflg == 1){
			com7_rx_eflg = 0;
			switch(com7_rx_data){
			    case   '0': exit_flg = 1; break;
			    case   '1': i = j = cnt = 0;
					printf("\r\nREAD(########(A),***(C)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
				    		if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
					    			buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
					    			buff2[j++] = ch;
					    			buff2[j] = 0x0;
							}
				    		}
					    		ch = buff[i++];
					}
					if(cnt == 1){		// ˻ 
						saddr = (unsigned)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned)atoh(buff2);// ī ȯ(HEX)
						printf("%08lX > ",saddr);// ּ ǥ
						cnt = 0;
				   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ	
							uch = sdram_addr[saddr];//  
							printf("%02X ",uch);// Ÿ ǥ
							cnt++;
							if(cnt == 16){// 1 ǥ
								cnt = 0;
								if(i+1 <= ecnt) printf("\r\n%08lX > ",saddr+1);// ּ ǥ
							}
					    	}
						printf("\r\nRead OK\r\n");
					}
					break;
			    case  '2' : i = j = cnt = 0;
					printf("\r\nWRITE(########(A),***(C),**(D)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
						if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
								buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
								buff2[j++] = ch;
								buff2[j] = 0x0;
							}
							else if(cnt == 2){
								buff3[j++] = ch;
								buff3[j] = 0x0;
							}
						}
							    ch = buff[i++];
					}
					if(cnt == 2){		// ˻ 
						saddr = (unsigned)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned)atoh(buff2);// ī ּ ȯ(HEX)
						uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
						for(i = 0; i <= ecnt; i++,saddr++){
							sdram_addr[saddr] = uch;//  
						}
						printf("SDRAM Data Write OK\r\n");
					}
					break;
		    	    default   : putchar(com7_rx_data); break;
			}
		}
	}
	com7_rx_eflg = 0;
	main_menu_disp();					// ޴ ǥ

// EBI ʱȭ
	PORTH.OUT = 0x00;
	PORTH.DIR = 0x00;
	PORTJ.OUT = 0x00;
	PORTJ.DIR = 0x00;
	PORTK.OUT = 0x00;
	PORTK.DIR = 0x00;
	PORTQ.OUT = 0x00;					// XTAL2 
	PORTQ.DIR = 0x00;
	EBI.CTRL = 0x00;					// ebi disable
}


// ============================ κ ڿ  ====================
// [μ] char buff[]					     
// Item1   Ÿ  (ִ 30)			     
// ----------------------------------------------------------------------------
void urx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	com7_rx_eflg = 0;
	buff[0] = 0x0;						//  ũ
	while(exit_flg == 0){
	    while(com7_rx_eflg == 0); com7_rx_eflg = 0;		// 1 
	    ch = com7_rx_data;					//  Ÿ ε
	    ch = toupper(ch);					//  ȯ
	    if(ch == 0x08){					// BSŰ м
			if(scnt == 0) putchar(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    putchar(0x08);
			    putchar(' ');
			    putchar(0x08);
			    scnt--;
			}
	    }
	    else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			printf("\r\n");
	    }
	    else{
			buff[scnt++] = ch;			// ڷ 
			putchar(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    putchar(0x08);
			    putchar(0x07);
			}
	    }
	}
}

// ========================== ASCII͸ HEXͷ ȯ ==================
// [μ] unsigned char buff[]					    
// Item1  ȯ  					    
// [] 0 - 7fffffffh 					    
// ----------------------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 					//  ε
	ch = toupper(ch);					// 빮 ȯ
	while(ch != 0){
		ch = ch - '0';              			// 0 - 9 ȯ 
		if(ch > 9) ch = ch - 7;				// A - F ȯ
		if(ch >= 0 && ch <= 0x0f) ch = ch & 0x0f;	//  ˻
		else ch = 0;
		data = data << 4;				// ȯ  
		data |= ch;
		ch = buff[i++];					//  ε
		ch = toupper(ch);				// 빮 ȯ 
	}
	return(data);
}
